<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xslt"
                xmlns:dodst="org.enhydra.dods.xslt.DODSTag"
                xmlns:stu="org.ejen.ext.StringUtil"
                version="1.0">
    <xsl:output method="text" encoding="iso-8859-1"/>
<xsl:template name="fileFooter4">
<xsl:if test="not(IS_CONSTANT='true')">
<xsl:if test="DO_IS_OID_BASED='true'">
            /* The ObjecId/Version columns form the primary key.  */
            setPrepStmtParam_BigDecimal( stmt, param, getOId().toBigDecimal() );
            setPrepStmtParam_int( stmt, param, getNewVersion() );
</xsl:if>
        } catch ( Exception e ) {
            throw new SQLException( "Data Object error: " + e.getMessage() );
        }
        statistics.incrementInsertNum();
        return stmt;
    }

    /**
     * Prepares the statement used to update this object
     * in the database.
     *
     * @param conn The database connection
     *
     * @return The update statement.
     *
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getUpdateStatement(DBConnection conn)
    throws SQLException {

        PreparedStatement stmt = conn.prepareStatement(
            <xsl:if test="DO_IS_OID_BASED='true'">&quot;Update <xsl:value-of select="TABLE_NAME"/> set &quot; + 
            getVersionColumnName() + &quot; = ?, <xsl:value-of select="dodst:updateQualQuestionMarks()"/> &quot; + 
            &quot;where <xsl:value-of select="dodst:updateWhereClause()"/>&quot;</xsl:if>
            <xsl:if test="DO_IS_OID_BASED='false'">&quot;update <xsl:value-of select="TABLE_NAME"/> set &quot; +
            &quot;<xsl:value-of select="dodst:updateQualQuestionMarks()"/> &quot; + 
            &quot;where <xsl:value-of select="dodst:updateWhereClause()"/>&quot;</xsl:if>
        );

        param = new int[1]; param[0] = 1;
        try {
<xsl:if test="DO_IS_OID_BASED='true'">            setPrepStmtParam_int( stmt, param, getNewVersion() );
</xsl:if></xsl:if>
</xsl:template>
</xsl:stylesheet>
