<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xslt"
                xmlns:dodst="org.enhydra.dods.xslt.DODSTag"
                xmlns:stu="org.ejen.ext.StringUtil"
                version="1.0">
    <xsl:output method="text" encoding="iso-8859-1"/>
<xsl:template name="fileFooter6">
<xsl:if test="not(IS_CONSTANT='true')">
        } catch ( Exception e ) {
            throw new SQLException( "Data Object error: " + e.getMessage() );
        }
        statistics.incrementUpdateNum();
        return stmt;
    }

    /**
     * Prepares the statement used to delete this object
     * from the database.
     *
     * @param conn The database connection
     *
     * @return The delete statement.
     *
     * @exception java.sql.SQLException if an error occurs.
     */
    public PreparedStatement getDeleteStatement(DBConnection conn)
    throws SQLException {
        String sql =<xsl:if test="DO_IS_OID_BASED='true'">
            &quot;delete from <xsl:value-of select="TABLE_NAME"/> \n&quot; +
            &quot;where &quot; + getOIdColumnName() + &quot; = ?&quot;;</xsl:if>
<xsl:if test="DO_IS_OID_BASED='false'">
            &quot;delete from <xsl:value-of select="TABLE_NAME"/> where <xsl:value-of select="dodst:updateWhereClause()"/>&quot;;</xsl:if>
        PreparedStatement stmt = conn.prepareStatement(sql);<xsl:if test="DO_IS_OID_BASED='true'">
        stmt.setBigDecimal(1, getOId().toBigDecimal());</xsl:if>
        statistics.incrementDeleteNum();
        return stmt;
    }
<xsl:if test="DO_IS_OID_BASED='false'">
    // for non-oid-based DOs, no fancy analysis on update failure.
    public synchronized void executeUpdate(DBConnection conn)
    throws SQLException, DBRowUpdateException {
        PreparedStatement stmt = getUpdateStatement(conn);
        if (stmt != null) {
            if ( 0 == conn.executeUpdate(stmt, "execute update") )
                    throw new DBRowUpdateException( "Zero rows were affected by the update.\n" + "The Primary Key was not found.\n" +
            this.toString() );
        }
    }</xsl:if></xsl:if>

    /*
     * toString - for debugging
     *
     * @return String for debugging.
     *
     */
    public String toString(){
        return toString( 1 );
    }

    public String toString( int indentCount ){
        String indent = "";
        for ( int i = 0; i &lt; indentCount; i++ ) {
            indent += ". ";
        }
        StringBuffer sb = new StringBuffer();
        sb.append(indent + &quot;<xsl:value-of select="CLASS_NAME"/>DO:&quot;);
<xsl:if test="DO_IS_OID_BASED='true'">
        ObjectId oid = getOId();
        String id = "virgin";
        if ( null != oid )
            id = oid.toString();
        sb.append(" OID=" + id + ",VERSION=" + getVersion());</xsl:if>
        if ( null != data ) {</xsl:template> 
</xsl:stylesheet>
