package discRack.presentation;

import discRack.presentation.delements.*;
import discRack.presentation.dpanels.*;
import discRack.business.person.PersonFactory;

import java.util.*;
import java.io.*;
import javax.swing.*;

/**
 * Used to manager Person DO data.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class Person extends DComplexElement {
   private DSimpleElement refFirstname=new DSimpleElement("First Name");
   private DSimpleElement refLastname=new DSimpleElement("Last Name");
   private DSimpleElement refLogin=new DSimpleElement("Login Name");
   private DSimpleElement refPassword=new DSimpleElement("Password",false,true);
   private DSimpleElement refREPassword=new DSimpleElement("Re-enter Password",false,true);

   public Person () {
      super("Please Register");

      fillStructure();
   }

   protected void fillStructure () {
      refFirstname.setRequired(true);
      refLastname.setRequired(true);
      refLogin.setRequired(true);
      refPassword.setRequired(true);
      complexStructure.add(refFirstname);
      complexStructure.add(refLastname);
      complexStructure.add(refLogin);
      complexStructure.add(refPassword);
      complexStructure.add(refREPassword);
   }

   /**
     * This method is called only if user doesn't press Cancel button within
     * the dialog for editing properties, so the changes are applied here.
     * @param groupPanel The panel for editing parameters.
     * @return always returns <tt>true</tt>.
     */
    public boolean setDODSElements (DPanel p) {
       DGroupPanel dgp=(DGroupPanel)p;
       DTextPanel fntp=(DTextPanel)dgp.getPanel(0);
       DTextPanel lntp=(DTextPanel)dgp.getPanel(1);
       DTextPanel ltp=(DTextPanel)dgp.getPanel(2);
       DTextPanel ptp=(DTextPanel)dgp.getPanel(3);
       DTextPanel rptp=(DTextPanel)dgp.getPanel(4);

       String firstname=fntp.getText();
       String lastname=lntp.getText();
       String login=ltp.getText();
       String password=ptp.getText();
       String repassword=rptp.getText();

       if (!password.equals(repassword)) {
          JOptionPane.showMessageDialog(p.getWindow(),
                "Re-entered password is not the same as password, please enter it again!",
                "Registering error", JOptionPane.ERROR_MESSAGE);
          return false;
       }
       try {
          discRack.business.person.Person pers=new discRack.business.person.Person();
          pers.setFirstname(firstname);
          pers.setLastname(lastname);
          pers.setLogin(login);
          pers.setPassword(password);
          pers.save();
// THIS SHOULD BE REMOVED WHEN I INCLUDE DODS
          //PersonFactory.addP(pers);
          return true;
       } catch (Exception ex) {
          JOptionPane.showMessageDialog(p.getWindow(),
                "Something went wrong, please try again !","Registering error",
                JOptionPane.ERROR_MESSAGE);
          return false;
       }
    }
}
